<?php
/**
* Online Public Access Catalog (OPAC) at OpenBiblio for Joomla!
* @version 1.0.4
* @package obiblioOPAC4J
* @copyright (C) 2005 Adriano dos Santos Vieira
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/
 
/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or
    die( 'Direct Access to this location is not allowed.' );

if (!($acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'all' )
| $acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'com_obiblioopac4j' ))) {
	mosRedirect( 'index2.php', _NOT_AUTH );
}

// include support libraries
require_once( $mainframe->getPath( 'class' ) );
require_once( $mainframe->getPath( 'admin_html' ) );

// handle the task
$task = mosGetParam( $_REQUEST, 'task', '' );

switch ($task) {
    case 'cfg_obiblioopac4j':
    default:
        showObibConfig();
        break;
    case 'save':
        $_obibsetup = mosGetParam( $_REQUEST, 'obibsetup', array(0) );
        
        SaveObibConfig($_obibsetup);
        break;
    case 'translate_obiblioopac4j':
        translate_obiblioopac4j();
        break;
        
    case 'about_obiblioopac4j':
        aboutObiblioopac4j();
        break;
        
    case 'cancel':
            mosRedirect( 'index2.php' );
            break;
    
}


/**
 * Show obiblio configuration event
 */
function showObibConfig() {

    obiblioAdmin::showObibConfig();
}

/**
 * Show obiblio configuration event
 */
function SaveObibConfig($_obibsetup) {

    obiblioAdmin::SaveObibConfig($_obibsetup);
}

/**
 * Show obiblio translation event
 */
function translate_obiblioopac4j() {

    obiblioAdmin::translate_obiblioopac4j();
}

/**
 * Show obiblio about event
 */
function aboutObiblioopac4j() {

    obiblioAdmin::aboutObiblioopac4j();
}
?>
