var req;

function loadXMLDoc(url)
{
    req = null;
    // Procura por um objeto nativo (Mozilla/Safari)
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", url, true);
        req.send(null);
    // Procura por uma versão ActiveX (IE)
    } else if (window.ActiveXObject) {
        req = new ActiveXObject("Microsoft.XMLHTTP");
        if (req) {
            req.onreadystatechange = processReqChange;
            req.open("GET", url, true);
            req.send();
        }
    }
}

function processReqChange()
{
    // apenas quando o estado for "completado"
    if (req.readyState == 4) {
        // apenas se o servidor retornar "OK"
        if (req.status == 200) {
            // procura pela div id="news" e insere o conteudo
            // retornado nela, como texto HTML
            document.getElementById('news').innerHTML = req.responseText;
        } else {
            alert("Houve um problema ao obter os dados:\n" + req.statusText);
        }
    }
}

function buscarNoticias(valor)
{
    loadXMLDoc("news.php?title="+valor);
}

// Recarrega a cada 60000 milissegundos (60 segundos)
function intervalo()
{
   setInterval("buscarNoticias()", 30000);
}

function sampleAJAX()
{
    var C=null;
    try
    {
        // try IE
        C=new ActiveXObject("Msxml2.XMLHTTP")
    }
    catch(e){
        try{
            // try IE again
            C=new ActiveXObject("Microsoft.XMLHTTP")
            }
            catch(sc){
                C=null
            }
        }
        if(!C&&typeof XMLHttpRequest!="undefined")
        {
            // elsewhere a better browser ;-)
            C=new XMLHttpRequest()
        }
        return C
    }

//var obj = new XMLHttpRequest();

var obj = sampleAJAX();
