<?
/**
 * @version 0.0.1
 * @package obiblioopac4j
 * @name OpenBilioOPAC for Joomla!
 * @author Adriano dos Santos Vieira (Harpiain - harpiain at users.sourceforge.net)
 * @date Dez, 2005
 * @license GPL
 *
 * @description Este componente (OpenBiblioOPAC) foi criado com a finalidade de dar suporte a consultas publicas aos usurios do pacote OpenBiblio (http://obiblio.sourceforge.net) dentro do CMS - Joomla!
 *
 * @note Ainda tenho muito o que fazer
 *
 */

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class oBiblioOPAC4J extends mosDBTable {
	
	/**
     * array contento as definicoes de idioma
     */
	var $obib = array();
    
	/**
     * array contento as definicoes do BD oBiblio
     */
    var $obib_host = array();

	/**
     * objeto contento as definicoes de idioma
     */
	var $objLang;
    
	
	function oBiblioOPAC4J() {
        global $mainframe, $mosConfig_lang;

        include_once($mainframe->getPath( 'admin_html' ));

        $this->objLang =& obiblioAdmin::create_Translator();    
 	}	


    /**
     * Static method to connect at Database
     * @return link
     */
    function oBiblioConnect() {
        $_link = mysql_connect($this->obib_host['hostname'], 
                                                 $this->obib_host['username'], 
                                                 $this->obib_host['userpwd']);
        if (!$_link) {
           //echo('Não foi possível conectar: ' . mysql_error());
        }
        //echo 'Conexão bem sucedida';
        return $_link;
    }
    
    /**
     * Static method to close Database connection
     * @return boolean
     */
    function oBiblioClose($_link) {
        $_close = @mysql_close($_link);
        if (!$_close) {
           //echo('Não foi possível desconectar: ' . mysql_error());
        }
        //echo 'Desconexão bem sucedida';
        return $_close;
    }
    
    /**
     * Static method to create the template object
     * @return patTemplate
     */
    function &createTemplate() {
        global $option, $mosConfig_absolute_path;
        require_once($mosConfig_absolute_path.'/includes/patTemplate/patTemplate.php' );
		
        $tmpl =& patFactory::createTemplate();
        $tmpl->setRoot( dirname( __FILE__ ) . '/tmpl' );
        $tmpl->readTemplatesFromInput('obibopac_tmpl.html' );
 
        return $tmpl;
    }

    /**
     * show obiblio OPAC event
     * @param array The server data configuration
     */
    function ObibOPACTmpl() {
        // import the body of the page
        $tmpl =& oBiblioOPAC4J::createTemplate();
        $tmpl->setAttribute( 'body', 'src', 'obibopac_tmpl.html' );
        
        return $tmpl;
    }
	
    /**
     * show obiblio OPAC event
     * @param array The server data configuration
     */
    function ObibOPACTmpl_Search( $_obib, $tmpl ) {
        global $Itemid, $option;
		
        // import the body of the page
        $tmpl->addVar( 'obibopac_search', 'obib_frontend_title', $this->objLang->GetText("#obib_frontend title#"));
        $tmpl->addVar( 'obibopac_search', 'obib_frontend_search_info', $this->objLang->GetText("#obib_frontend search info#"));
        $tmpl->addVar( 'obibopac_search', 'obib_frontend_search', $this->objLang->GetText("#obib_frontend search#"));
        $tmpl->addVar( 'obibopac_search', 'obib_frontend_info', $this->objLang->GetText("#obib_frontend info#"));
        
        $tmpl->addVar( 'obibopac_formend', 'ITEMID', $Itemid);
        $tmpl->addVar( 'obibopac_formend', 'OPTION', $option);
        $tmpl->addVar( 'obibopac_search', 'SEARCHTEXT', str_replace("\\",'',$_obib['search']['searchText'] ));		
        $tmpl->displayParsedTemplate('obibopac_search');
    }
	
	/**
	 * Show obiblio Search result
	 */
	function searchObibText($_obib, $option, $tmpl) {
        global $mainframe, $database;
        
        $_obib_search = $_obib['search'];
        
        $_sql_count = "SELECT COUNT(*) FROM ".$this->obib_host['database'].".biblio";
        $_sql_select = "SELECT * FROM ".$this->obib_host['database'].".biblio";
        $_sql_where = " where  opac_flg = 'Y'";
        
        if ($_obib_search['searchText']) {
            
            $_searchFilter = $this->oBiblioBuildSearchFilter( $_obib_search['searchText'],
                                                                               array('title','title_remainder','author','topic1','topic2','topic3','topic4','topic5'));
                                                                               
            $_sql_where .= " and ( ";
            $_sql_where .= $_searchFilter;
            $_sql_where .= ")";
        } 
        
        // Bloco de paginacao
        $admin_page_itens = oBiblioOPAC4J::oBiblioGetAdminSetupPages();
        $admin_page_counter = oBiblioOPAC4J::oBiblioGetAdminSetupPagesCounter();
        
        $_sql_counter = $_sql_count  . $_sql_where;
        $database->setQuery( $_sql_counter);
        
        $page_total = $database->loadResult();
        
        $limit = $admin_page_itens;
        $page_show=  mosGetParam( $_REQUEST, 'opacpage_show', '' );
        if(empty($page_show)) $page_show = 1;
        
        // obtem primeiro registro da pagina a ser mostrada
        $limitstart =  $limit * $page_show; 
        if($limitstart != 0)
           $limitstart -= $limit;
        
        if($limit != 0 )
            // ultima pagina a ser mostrada
          $page_last = ceil($page_total/$limit);
          
        if(($page_show+$admin_page_counter) < $page_last)
            $page_next = $page_show + $admin_page_counter;
        else
            $page_next = $page_last;
            
        if(($page_show-$admin_page_counter)  > 1 )
            $page_back = $page_show - $admin_page_counter;
        else
            $page_back = 1;
        
        $_sql_limit = " LIMIT $limitstart,$limit";

        if(($page_show+$admin_page_counter) <= $page_last) {
            $page_counter = $page_show+$admin_page_counter;
            //if( $page_show=1) $page_counter--;
        }
        else
            $page_counter = $page_last+1;
        $_pages = array();    
        for ($i=$page_show; $i < $page_counter; $i++) {
            $_arrAux = array(
                                           array('pages' => $i
                                                 )
                                           );
            
            $_pages = array_merge($_pages, $_arrAux);
        }  // end for

        $tmpl->addVar( 'obibopac_pagenav', 'PAGECOUNTER', 
                                 $page_total." ".$this->objLang->GetText("#obib_frontend search result#"));
        $tmpl->addVar( 'obibopac_pagenav', 'PAGEFIRST', "1");
        $tmpl->addVar( 'obibopac_pagenav', 'PAGEBACK', $page_back);
        $tmpl->addVar( 'obibopac_pagenav', 'PAGENEXT', $page_next);
        $tmpl->addVar( 'obibopac_pagenav', 'PAGELAST', $page_last);
        
        $tmpl->addVar( 'pages', 'PAGE', $page_back);
        $tmpl->addRows( 'list_pages', $_pages);
        
        // fim_paginacao

        $_sql_orderby = " order by title" ;

        $_sql = $_sql_select  . $_sql_where . $_sql_orderby . $_sql_limit;
        oBiblioOPAC4J::oBiblioConnect();

        $database->setQuery($_sql );
        $arrBiblio = $database->loadObjectList(); 
        
        oBiblioOPAC4J::oBiblioShowOPACItens($arrBiblio, $option, $pageNav, $tmpl);	
        
	}
    
	/**
	 * Bild obiblio Search filter
     * @todo  a implementar caso de uso com aspas simples ou duplas (agrupar strings)
     * @since 1.0.0-6
	 */
	function oBiblioBuildSearchFilter( $_searchText, $_fieldsArray ) {
        if(is_string($_fieldsArray))
            $_fieldsArray = explode(',',$_fieldsArray);
        
        $_searchText = str_replace("'","",$_searchText);
        $_searchText = str_replace('"','',$_searchText);
        $_searchText = str_replace("\\",'',$_searchText);
        $_searchText = explode(" ",$_searchText);        
            
        if(is_array($_fieldsArray)) {
            
            //$_pos  = strpos($_searchText,"'") or strpos($_searchText,'"'); 
            foreach( $_fieldsArray as $_field ) {
                foreach( $_searchText as $_text ) {
                    if(!empty($_searchFilter))
                        $_searchFilter .= " or ";
                        
                    $_searchFilter .=  " $_field  like '%$_text%' ";
                }
            }
            
            return $_searchFilter;
        }
        else
            return false;
    }

	/**
	 * Show obiblio Search result - itens datails
	 */
	function oBiblioShowOPACItens( $rows, $option, $pageNav, $tmpl) {
        global $Itemid;

             $_list = array();

             for ($i=0, $n=count( $rows ); $i < $n; $i++) {
                $row = &$rows[$i];
                $_oBiblioCopies = oBiblioOPAC4J::oBiblioCopies($row->bibid);
                $_oBiblioMaterial = oBiblioOPAC4J::oBiblioMaterial($row->material_cd);
                $_oBiblioColecao = oBiblioOPAC4J::oBiblioColecao($row->collection_cd);
                $_bibidNumCopies =count( $_oBiblioCopies );
                
                $_detalha_copias ="";
                for ($i2=0, $_bibidNumCopies; $i2 < $_bibidNumCopies; $i2++) {
                    $row2 = &$_oBiblioCopies[$i2];
                    $_oBiblioStatus = oBiblioOPAC4J::oBiblioStatus($row2->status_cd);
                    $_detalha_copias .= '<tr> ';
                    $_detalha_copias .= "
                                                <td>".$row2->barcode_nmbr."</td>
                                                <td>".$row2->copy_desc."</td>
                                                <td align='center'>".$_oBiblioStatus[0]->description."</td>
                                                <td align='center'>".$row2->due_back_dt."</td>";
                    $_detalha_copias .= '</tr>';
                }  // end for
                
                $_assunto = "";
                if(!empty($row->topic1)) $_assunto  = $row->topic1;
                if(!empty($row->topic2)) $_assunto .= "; " . $row->topic2;
                if(!empty($row->topic3)) $_assunto .= "; " . $row->topic3;
                if(!empty($row->topic4)) $_assunto .= "; " . $row->topic4;
                if(!empty($row->topic5)) $_assunto .= "; " . $row->topic5;
                
                $_arrAux = array(
                                               array('BIBID' => $row->bibid,
                                                     'TITLE' => $row->title,
                                                     'VERDETALHES' => $this->objLang->GetText('#obib_frontend item detail#'),
                                                     'AUTOR' => $row->author,
                                                     'MATERIAL_TIT' => $this->objLang->GetText("#obib_material#"),
                                                     'MATERIAL' => $_oBiblioMaterial[0]->description,
                                                     'COLECAO_TIT' => $this->objLang->GetText("#obib_colecao#"),
                                                     'COLECAO' => $_oBiblioColecao[0]->description,
                                                     'NUMCHAMADA_TIT' => $this->objLang->GetText("#obib_num chamada#"),
                                                     'NUMCHAMADA' => $row->call_nmbr1." ".$row->call_nmbr2." ".$row->call_nmbr3,
                                                     'TITDESCRICAO_TIT' => $this->objLang->GetText('#obib_descricao#'),
                                                     'TITDESCRICAO' => $row->title_remainder, 
                                                     'TITASSUNTO_TIT' => $this->objLang->GetText('#obib_assunto#'),
                                                     'TITASSUNTO' => $_assunto, 
                                                     'NUMCOPIAS_TIT' => $this->objLang->GetText('#obib_copias existentes#'),
                                                     'NUMCOPIAS' => $_bibidNumCopies,
                                                     'COPIESDATAILS' => $_detalha_copias
                                                     )
                                               );

              $_list = array_merge($_list, $_arrAux);
            }  // end for
        
        // cria e mostra o templates
        $tmpl->addVar( 'obibopac_result', 'ITEMID', $Itemid);
        $tmpl->addVar( 'obibopac_result', 'OPTION', $option);
        
        $tmpl->addVar( 'obibopac_result', 'OBIBHEADER', $this->objLang->GetText('#obib_frontend result title#'));
        $tmpl->addVar( 'obibopac_result', 'OBIBHEADER_TITLE', $this->objLang->GetText('#obib_frontend book title#'));
        $tmpl->addVar( 'obibopac_result', 'AUTOR_TIT', $this->objLang->GetText('#obib_frontend book author#'));
        $tmpl->addVar( 'obibopac_result', 'PAGEFOOTER', $pag_atual);
        
        $tmpl->addVar( 'list_entry', 'CODBARRA_TIT', $this->objLang->GetText('#obib_codigo de barras#'));
        $tmpl->addVar( 'list_entry', 'COPYDESC_TIT', $this->objLang->GetText('#obib_descricao#'));
        $tmpl->addVar( 'list_entry', 'STATUS_TIT', $this->objLang->GetText('#obib_status#'));
        $tmpl->addVar( 'list_entry', 'DUEBACKDATE_TIT', $this->objLang->GetText('#obib_devolucao#'));
        $tmpl->addRows( 'list_entry', $_list);
        
        $tmpl->displayParsedTemplate( 'obibopac_pagenav' );
        $tmpl->displayParsedTemplate( 'obibopac_result' );
        $tmpl->displayParsedTemplate( 'obibopac_pagenav' );
	}
    
    function oBiblioStatus($_code) {
        global $database;
        $_sql_select = "SELECT * FROM ".$this->obib_host['database'].".biblio_status_dm";
        $_sql_where = " where  code = '". $_code ."'";
        $_sql = $_sql_select  . $_sql_where;
        $database->setQuery($_sql);
        return $database->loadObjectList();
    }
    
    function oBiblioCopies($_bibid) {
        global $database;
        $_sql_select = "SELECT * FROM ".$this->obib_host['database'].".biblio_copy";
        $_sql_where = " where  bibid = '". $_bibid ."'";
        $_sql = $_sql_select  . $_sql_where;
        $database->setQuery($_sql);
        return $database->loadObjectList();
    }
    
    function oBiblioMaterial($_code) {
        global $database;
        $_sql_select = "SELECT * FROM ".$this->obib_database.".material_type_dm";
        $_sql_where = " where code = '". $_code ."'";
        $_sql = $_sql_select  . $_sql_where;
        $database->setQuery($_sql);
        return $database->loadObjectList();
    }

    function oBiblioColecao($_code) {
        global $database;
        $_sql_select = "SELECT * FROM ".$this->obib_database.".collection_dm";
        $_sql_where = " where  code = '". $_code ."'";
        $_sql = $_sql_select  . $_sql_where;
        $database->setQuery($_sql);
        return $database->loadObjectList();
    }
    
    function oBiblioSetObibHost($_obib_host) {
        $this->obib_host = $_obib_host;
        return ;
    }
    
    function oBiblioGetAdminSetup() {
        global $database;
        $_sql_select = "SELECT * FROM #__obiblioopac4j_obibsetup ";
        $_sql = $_sql_select;
        $database->setQuery($_sql);
        return $database->loadObjectList();
    }
    
    function oBiblioGetAdminSetupPages() {
        $_admin_setup = oBiblioOPAC4J::oBiblioGetAdminSetup();
        
        return $_admin_setup[0]->obibpageitens;
    }
    
    function oBiblioGetAdminSetupPagesCounter() {
        $_admin_setup = oBiblioOPAC4J::oBiblioGetAdminSetup();
        
        return $_admin_setup[0]->obibpagecounter;
    }
    
}

?>
