<?
/**
* Online Public Access Catalog (OPAC) at OpenBiblio for Joomla!
* @version 0.0.1
* @package obiblioOPAC4J
* @copyright (C) 2005 Adriano dos Santos Vieira
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* @name OpenBilioOPAC for Joomla!
* @author Adriano dos Santos Vieira (Harpia In - harpiain at users.sourceforge.net)
* @date Dez, 2005

@description Este componente (OpenBiblioOPAC) foi criado com a finalidade de dar suporte a consultas publicas aos usurios do pacote OpenBiblio (http://obiblio.sourceforge.net) dentro do CMS - Joomla!

*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* Online Public Access Catalog (OPAC) at OpenBiblio for Joomla!
* @version 1.0.4
* @package obiblioOPAC4J
* @copyright (C) 2005 Adriano dos Santos Vieira
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/
 
/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or
    die( 'Direct Access to this location is not allowed.' );
 
// include support libraries
require_once( $mainframe->getPath( 'class' ) );

$objObib = new oBiblioOPAC4J;
$_admin_setup = oBiblioOPAC4J::oBiblioGetAdminSetup();

$obib['host']['hostname'] = $_admin_setup[0]->obibhostname;
$obib['host']['database'] = $_admin_setup[0]->obibdatabase;
$obib['host']['username'] = $_admin_setup[0]->obibusername;
$obib['host']['userpwd'] = $_admin_setup[0]->obibuserpass;
$objObib->oBiblioSetObibHost($obib['host']);

 
// handle the task
$task = mosGetParam( $_REQUEST, 'task', '' );
$option = mosGetParam( $_REQUEST, 'option', '' );
$Itemid = mosGetParam( $_REQUEST, 'Itemid', '' );

$obib['search']['searchType'] = mosGetParam( $_REQUEST, 'searchType', array(0) );
$obib['search']['searchText'] = mosGetParam( $_REQUEST, 'searchText', '' );
$obib['search']['sortBy'] = mosGetParam( $_REQUEST, 'sortBy', array(0) );
$obib['search']['tab'] = mosGetParam( $_REQUEST, 'tab', array(0) );
$obib['search']['lookup'] = mosGetParam( $_REQUEST, 'lookup', array(0) );

/* fiz isso para poder usar o "method=post" no "form" 
 * - O Frontend do Joomla faz esta requisicao para mostrar
 *   "pathWay". Assim, fiz isso para usar o POST. ;-)
 * 
 * Verificar depois se realmente é necessário
 */
//$QUERY_STRING = "option=com_obiblioopac4j&Itemid=".$Itemid;
//$REQUEST_URI ="/index.php?option=com_obiblioopac4j&Itemid=".$Itemid;

$tmpl = oBiblioOPAC4J::ObibOPACTmpl();
$tmpl->displayParsedTemplate('obibopac_form'); // imrime tag <FORM ...>

$objObib->ObibOPACTmpl_Search($obib, $tmpl);  
switch ($task) {
    case 'obibopac_search':
        $objObib->searchObibText( $obib, $option, $tmpl );
        break;
}

$tmpl->displayParsedTemplate('obibopac_formend'); // imrime tag </FORM>

?>
